# Copyright (c) 2016 BaseSoft B.V.
# See LICENSE for details.

from sqlalchemy import and_, text

from pvcycle.order.configurable_widgets.declaration_result import DeclarationResultWidget
from pvcycle.order.configurable_widgets.contribution_result import ContributionResultWidget
from pvcycle.order.configurable_widgets.order_result import PvcOrderResultWidget

def procedures():

    return [
        """
        DROP VIEW IF EXISTS `viewPvcIsFullMember`
        """,
        """
        CREATE VIEW viewPvcIsFullMember AS
        SELECT 0 as 'is_full_member', 'Non-full Member' as 'is_full_member_label'
        UNION
        SELECT 1 as 'is_full_member', 'Full Member' as 'is_full_member_label'
        """,
        """
        DROP VIEW IF EXISTS `viewPvcHasVotingRights`
        """,
        """
        CREATE VIEW viewPvcHasVotingRights AS
        SELECT 0 as 'has_voting_rights', 'No voting rights' as 'has_voting_rights_label'
        UNION
        SELECT 1 as 'has_voting_rights', 'Has voting rights' as 'has_voting_rights_label'
        """,

        """
        DROP PROCEDURE IF EXISTS `pvcPopulateTbsProductClosure`
        """,
        """
        CREATE PROCEDURE pvcPopulateTbsProductClosure()
        BEGIN
            TRUNCATE TABLE closurePvcTbsProduct;

            INSERT INTO closurePvcTbsProduct (parent_level_id, product_level_id, distance)
                SELECT parent.id, child.id, closure.distance
                FROM tblPvcTbsProduct as parent
                INNER JOIN closureWEEEProductLevel as closure ON closure.parent_level_id = parent.product_id
                INNER JOIN tblPvcTbsProduct as child ON closure.product_level_id = child.product_id;

        END
        """

    ]

def post_sync(sa_session, app_name):
    if app_name != 'pvcycle.order':
        return

    # FIMXE
    # sa_session.execute(text('CALL pvcPopulateTbsProductClosure').execution_options(autocommit=True))


configurable_widgets = (DeclarationResultWidget, PvcOrderResultWidget, ContributionResultWidget, )
